{$A-,B-,D-,E-,F-,G-,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}

(* {$DEFINE LOGGING} *)

program FearfulDungeonsOfMoipk;

uses    Crt;

const   STEPS                   = 250;
	SPEED			= 0.07;
	MOVECOUNT		= 5;
	PROXIMITY		= 0.2;
	MAP_SCALE		= 0.35;
	ATTACK_PROXIMITY	= 0.55;
	FIREBALL_PROXIMITY	= 0.25;
	ALPHACOLOR		= 255;
	TEXCOUNT		= 17;
	RESPAWN_DISTANCE	= 10.0;

	MAX_FIRE		= 128;
	FIRE_SPEED		= 0.20;

	ITEM_COUNT		= 32;

	SPRITE_COUNT		= 384;

	MONSTER_COUNT		= 60;

	BOTTLE_COUNT		= 40;

	DISTANCE		= 22;

        SimCount                = 41;

	Sims			: array[ 1..SimCount ] of char = 
				( 'A','B','C','D','E','F','G','H','I','J','K','L',
				  'M','N','O','P','Q','R','S','T','U','V','W','X',
				  'Y','Z','0','1','2','3','4','5','6','7','8','9',
				  ':','!',' ','.',','
				);

        Faces                   : array[ 1..SimCount, 1..5,1..5 ] of byte =

        (

         (

           ( 0,1,1,1,0 ),
           ( 1,0,0,0,1 ),
           ( 1,1,1,1,1 ),
           ( 1,0,0,0,1 ),
           ( 1,0,0,0,1 )

         ),
         (

           ( 1,1,1,1,0 ),
           ( 1,0,0,0,1 ),
           ( 1,1,1,1,0 ),
           ( 1,0,0,0,1 ),
           ( 1,1,1,1,0 )

         ),
         (

           ( 0,1,1,1,1 ),
           ( 1,0,0,0,0 ),
           ( 1,0,0,0,0 ),
           ( 1,0,0,0,0 ),
           ( 0,1,1,1,1 )

         ),
         (

           ( 1,1,1,1,0 ),
           ( 1,0,0,0,1 ),
           ( 1,0,0,0,1 ),
           ( 1,0,0,0,1 ),
           ( 1,1,1,1,0 )

         ),
         (

           ( 1,1,1,1,1 ),
           ( 1,0,0,0,0 ),
           ( 1,1,1,1,0 ),
           ( 1,0,0,0,0 ),
           ( 1,1,1,1,1 )

         ),
         (

           ( 1,1,1,1,1 ),
           ( 1,0,0,0,0 ),
           ( 1,1,1,1,0 ),
           ( 1,0,0,0,0 ),
           ( 1,0,0,0,0 )

         ),
         (

           ( 0,1,1,1,1 ),
           ( 1,0,0,0,0 ),
           ( 1,0,1,1,1 ),
           ( 1,0,0,0,1 ),
           ( 0,1,1,1,0 )

         ),
         (

           ( 1,0,0,0,1 ),
           ( 1,0,0,0,1 ),
           ( 1,1,1,1,1 ),
           ( 1,0,0,0,1 ),
           ( 1,0,0,0,1 )

         ),
         (

           ( 1,1,1,1,1 ),
           ( 0,0,1,0,0 ),
           ( 0,0,1,0,0 ),
           ( 0,0,1,0,0 ),
           ( 1,1,1,1,1 )

         ),
         (

           ( 0,1,1,1,1 ),
           ( 0,0,0,1,0 ),
           ( 0,0,0,1,0 ),
           ( 1,0,0,1,0 ),
           ( 0,1,1,0,0 )
                
         ),
         (

           ( 1,0,0,0,1 ),
           ( 1,0,0,1,0 ),
           ( 1,1,1,0,0 ),
           ( 1,0,0,1,0 ),
           ( 1,0,0,0,1 )

         ),


         (

           ( 1,0,0,0,0 ),
           ( 1,0,0,0,0 ),
           ( 1,0,0,0,0 ),
           ( 1,0,0,0,1 ),
           ( 1,1,1,1,1 )

         ),
         (

           ( 1,0,0,0,1 ),
           ( 1,1,0,1,1 ),
           ( 1,0,1,0,1 ),
           ( 1,0,0,0,1 ),
           ( 1,0,0,0,1 )

         ),
         (

           ( 1,0,0,0,1 ),
           ( 1,1,0,0,1 ),
           ( 1,0,1,0,1 ),
           ( 1,0,0,1,1 ),
           ( 1,0,0,0,1 )

         ),
         (

           ( 0,1,1,1,0 ),
           ( 1,0,0,0,1 ),
           ( 1,0,0,0,1 ),
           ( 1,0,0,0,1 ),
           ( 0,1,1,1,0 )

         ),
         (

           ( 1,1,1,1,0 ),
           ( 1,0,0,0,1 ),
           ( 1,1,1,1,0 ),
           ( 1,0,0,0,0 ),
           ( 1,0,0,0,0 )

         ),
         (

           ( 0,1,1,1,0 ),
           ( 1,0,0,0,1 ),
           ( 1,0,0,0,1 ),
           ( 1,0,0,1,0 ),
           ( 0,1,1,0,1 )

         ),
         (

           ( 1,1,1,1,0 ),
           ( 1,0,0,0,1 ),
           ( 1,1,1,1,0 ),
           ( 1,0,1,0,0 ),
           ( 1,0,0,1,1 )

         ),
         (

           ( 0,1,1,1,1 ),
           ( 1,0,0,0,0 ),
           ( 0,1,1,1,0 ),
           ( 0,0,0,0,1 ),
           ( 1,1,1,1,0 )

         ),
         (

           ( 1,1,1,1,1 ),
           ( 0,0,1,0,0 ),
           ( 0,0,1,0,0 ),
           ( 0,0,1,0,0 ),
           ( 0,0,1,0,0 )

         ),
         (

           ( 1,0,0,0,1 ),
           ( 1,0,0,0,1 ),
           ( 1,0,0,0,1 ),
           ( 1,0,0,0,1 ),
           ( 0,1,1,1,0 )

         ),
         (

           ( 1,0,0,0,1 ),
           ( 1,0,0,0,1 ),
           ( 0,1,0,1,0 ),
           ( 0,1,0,1,0 ),
           ( 0,0,1,0,0 )

         ),
         (

           ( 1,0,0,0,1 ),
           ( 1,0,1,0,1 ),
           ( 1,0,1,0,1 ),
           ( 1,0,1,0,1 ),
           ( 0,1,0,1,0 )

         ),
         (

           ( 1,0,0,0,1 ),
           ( 0,1,0,1,0 ),
           ( 0,0,1,0,0 ),
           ( 0,1,0,1,0 ),
           ( 1,0,0,0,1 )

         ),
         (

           ( 1,0,0,0,1 ),
           ( 0,1,0,1,0 ),
           ( 0,0,1,0,0 ),
           ( 0,0,1,0,0 ),
           ( 0,0,1,0,0 )

         ),
         (

           ( 1,1,1,1,1 ),
           ( 0,0,0,1,0 ),
           ( 0,0,1,0,0 ),
           ( 0,1,0,0,0 ),
           ( 1,1,1,1,1 )

         ),
         (

           ( 0,1,1,1,0 ),
           ( 1,0,0,1,1 ),
           ( 1,0,1,0,1 ),
           ( 1,1,0,0,1 ),
           ( 0,1,1,1,0 )

         ),
         (

           ( 1,1,1,0,0 ),
           ( 0,0,1,0,0 ),
           ( 0,0,1,0,0 ),
           ( 0,0,1,0,0 ),
           ( 1,1,1,1,1 )

         ),
         (

           ( 0,1,1,1,0 ),
           ( 1,0,0,0,1 ),
           ( 0,0,0,1,0 ),
           ( 0,0,1,0,0 ),
           ( 1,1,1,1,1 )

         ),
         (

           ( 1,1,1,1,1 ),
           ( 0,0,0,1,0 ),
           ( 0,0,1,0,0 ),
           ( 0,0,0,1,0 ),
           ( 1,1,1,1,1 )

         ),
         (

           ( 1,0,0,0,1 ),
           ( 1,0,0,0,1 ),
           ( 1,1,1,1,1 ),
           ( 0,0,0,0,1 ),
           ( 0,0,0,0,1 )

         ),
         (

           ( 1,1,1,1,1 ),
           ( 1,0,0,0,0 ),
           ( 1,1,1,1,0 ),
           ( 0,0,0,0,1 ),
           ( 1,1,1,1,0 )

         ),
         (

           ( 0,1,1,1,1 ),
           ( 1,0,0,0,0 ),
           ( 1,1,1,1,0 ),
           ( 1,0,0,0,1 ),
           ( 1,1,1,1,0 )

         ),
         (

           ( 1,1,1,1,1 ),
           ( 0,0,0,0,1 ),
           ( 0,0,0,0,1 ),
           ( 0,0,0,1,0 ),
           ( 0,0,1,0,0 )

         ),
         (

           ( 0,1,1,1,0 ),
           ( 1,0,0,0,1 ),
           ( 0,1,1,1,0 ),
           ( 1,0,0,0,1 ),
           ( 0,1,1,1,0 )

         ),
         (

           ( 0,1,1,1,0 ),
           ( 1,0,0,0,1 ),
           ( 0,1,1,1,1 ),
           ( 0,0,0,0,1 ),
           ( 0,1,1,1,0 )

         ),
         (

           ( 0,0,0,0,0 ),
           ( 0,0,1,0,0 ),
           ( 0,0,0,0,0 ),
           ( 0,0,0,0,0 ),
           ( 0,0,1,0,0 )

         ),
         (

           ( 0,0,1,0,0 ),
           ( 0,0,1,0,0 ),
           ( 0,0,1,0,0 ),
           ( 0,0,0,0,0 ),
           ( 0,0,1,0,0 )

         ),
         (

           ( 0,0,0,0,0 ),
           ( 0,0,0,0,0 ),
           ( 0,0,0,0,0 ),
           ( 0,0,0,0,0 ),
           ( 0,0,0,0,0 )

         ),
         (

           ( 0,0,0,0,0 ),
           ( 0,0,0,0,0 ),
           ( 0,0,0,0,0 ),
           ( 0,1,0,0,0 ),
           ( 0,0,0,0,0 )

         ),
         (

           ( 0,0,0,0,0 ),
           ( 0,0,0,0,0 ),
           ( 0,0,0,0,0 ),
           ( 0,1,0,0,0 ),
           ( 1,0,0,0,0 )

         )

        );

type    PScreen                 = ^TScreen;
        TScreen                 = array [0..320*200-1] of Byte;

        PMap                    = ^TMap;
        TMap                    = array [0..63, 0..63] of Byte;

        PTexture		= ^TTexture;
        TTexture		= array [0..63, 0..63] of Byte;

        TSprite			= record

                                   Id      : LongInt;

                                   XX, YY  : Extended;

                                   Scale   : Extended;
                                   Diff    : Extended;

                                   Dist	   : Extended;

        			  end;

	TSpriteArr		= array [1..SPRITE_COUNT] of TSprite;

	TMonster		= record

				   Id	   : LongInt;

				   XX, YY  : Extended;

				   dX, dY  : Extended;

				   Moves   : LongInt;

				   Health  : LongInt;

				  end;

	TMonsterz		= array [1..MONSTER_COUNT] of TMonster;

var	MapMode			: Boolean;	

	Monsters		: TMonsterz;

	Timer			: LongInt absolute $0000 : $046C;

	GameEnded		: Boolean;

	LastFire		: LongInt;

{$IFDEF LOGGING}
	ouf			: Text;
{$ENDIF}

procedure _( S : String );
begin

 {$IFDEF LOGGING}
 WriteLn( ouf, S ); Flush( ouf );
 {$ENDIF}

end;

var	PlayerHealth				: LongInt;
	FireballsLeft				: LongInt;

procedure BeginVideo; assembler;
asm

 mov    ax,     13h
 int    10h

end;

procedure EndVideo; assembler;
asm

 mov    ax,     03h
 int    10h

end;

procedure SetPalette;
var i : LongInt;
begin

 Port[ $3c8 ] := 0;

 { --- red }

 for i := 0 to 31 do
 begin

  Port[ $3c9 ] := i+i;
  Port[ $3c9 ] := 0;
  Port[ $3c9 ] := 0;

 end;

 { --- green }

 for i := 0 to 31 do
 begin

  Port[ $3c9 ] := 0;
  Port[ $3c9 ] := i+i;
  Port[ $3c9 ] := 0;

 end;

 { --- blue }

 for i := 0 to 31 do
 begin

  Port[ $3c9 ] := 0;
  Port[ $3c9 ] := 0;
  Port[ $3c9 ] := i+i;

 end;

 { --- yellow }

 for i := 0 to 31 do
 begin

  Port[ $3c9 ] := i+i;
  Port[ $3c9 ] := i+i;
  Port[ $3c9 ] := 0;

 end;

 { --- orange }

 for i := 0 to 31 do
 begin

  Port[ $3c9 ] := i+i;
  Port[ $3c9 ] := i;
  Port[ $3c9 ] := 0;

 end;

 { --- neon }

 for i := 0 to 31 do
 begin

  Port[ $3c9 ] := 0;
  Port[ $3c9 ] := i;
  Port[ $3c9 ] := i+i;

 end;

 { --- gray }

 for i := 0 to 63 do
 begin

  Port[ $3c9 ] := i;
  Port[ $3c9 ] := i;
  Port[ $3c9 ] := i;

 end;

 { --- }

end;

var     Scr                    : PScreen;
        Map                    : PMap;
        Tex		       : array [0..TEXCOUNT] of PTexture;
        TexSize		       : array [0..TEXCOUNT] of LongInt;

        Spr		       : TSpriteArr;
        SprCount	       : LongInt;

        Angle          	       : Extended;
        X, Y           	       : Extended;

type	TBottle				= record

                                           XX, YY : Extended;

                                           Exist  : Boolean;						

					  end;

var	Bottles				: array [1..BOTTLE_COUNT] of TBottle;

	BottlesLeft			: LongInt;

type	TFireball	       = record

                                  XX, YY : Extended;
                                  dX, dY : Extended;

                                  Active : Boolean;

				 end;

var	Fires		       : array  [1..MAX_FIRE] of TFireball;

procedure Flip;
var i : LongInt;
begin

 for i := 0 to 320*200-1 do
  Mem[ $A000 : i ] := Scr^[ i ];

end;

procedure ReadMap;
var i, j : LongInt;
    inF  : Text;
    c    : Char;
begin

 Assign( inF, 'Map.Txt' ); ReSet( inF );

 ReadLn( inF, X, Y );

 X := X - 0.5;
 Y := Y - 0.5;

 for i := 0 to 63 do
 begin

  for j := 0 to 63 do
  begin

   Read( inF, c );

   if c = ' '
    then Map^[ i, j ] := 0
    else Map^[ i, j ] := Ord( c ) - Ord( '0' );

  end;

  ReadLn( inF );

 end;

 Close( inF );

end;

procedure Backbuf;
var i, j, k, z : LongInt;
begin

 z := 0;

 for i := 0 to 100-1 do
 begin

  k := { 128 + 32 + } (i * 16) div 100;

  for j := 0 to 319 do
  begin

   Scr^[ z ] := k;

   Inc( z );

  end;

 end;

 for i := 130-1 downto 30 do
 begin

  k := 191 + (63 * 30 div i);

  for j := 0 to 319 do
  begin

   Scr^[ z ] := k;

   Inc( z );

  end;

 end;

end;

procedure SetupGuy;
begin

 Angle := Pi ;

 MapMode := False;

end;

procedure MousedAngle;
var mX : Word;
begin

 asm

  mov	ax, 3
  int	33h

  mov	mX, cx

 end;

 Angle := Angle + ((mX - 500.0) / 2500.0) * (Pi + Pi);
 
 while Angle < 0 do
  Angle := Angle + Pi + Pi;

 while Angle > Pi + Pi do
  Angle := Angle - Pi - Pi;

 asm

  mov	ax,	4
  mov	cx,	500
  mov   dx,	0
  int	33h

 end;

end;

procedure MousePressed( var Button : Word ); assembler;
asm

 mov	ax, 5
 les	di, Button
 mov	bx, word ptr es:[di]
 int	33h
 mov	word ptr es:[di], ax

end;

var	Depths			: array [0..319] of Extended;


type	TItem		 	= record

                                   IsMedikit		: LongInt;

                                   XX, YY		: Extended;				  

				  end;

var	Items			: array [1..ITEM_COUNT] of TItem;


procedure Render;

 var      i, j : LongInt;
             a : Extended;
        cX, cY : Extended;
        sX, sY : Extended;
      cDX, cDY : Extended;
      cXI, cYI : Extended;
         cDist : Extended;

        X1, Y1 : Extended;
        X2, Y2 : Extended;
        L1, L2 : Extended;

        MX, MY : LongInt;
        TX, TY : LongInt;

         First : Boolean;

           ttX : Extended;
           ttY : Extended;
           ttZ : Extended;

            hX : LongInt; 
           hXf : Extended;

           tXs : LongInt;

	pX, pY : Extended;

      ffX, ffY : Boolean;	

    AngleDelta : Extended;

       kAlpha1 : Extended;
       kAlpha2 : Extended;

        kAlpha : Extended;

 procedure ComputeDeltas;
 begin

  if (a > (Pi/2)) and (a < (3*Pi/2))
   then cXI := -1.0
   else cXI := +1.0;

  if (a > Pi)
   then cYI := -1.0
   else cYI := +1.0;

  ffY := (cXI > 0);
  ffX := (cYI < 0);

  if Abs( a ) < 1e-4
   then begin

         cDX := +1e4;
         cDY := 0;

         Exit;

        end;

  if Abs( a - Pi ) < 1e-4
   then begin

         cDX := -1e4;
         cDY := 0;

         Exit;

        end;

  if Abs( a - (Pi / 2) ) < 1e-4
   then begin

         cDX := 0;
         cDY := +1e4;

         Exit;

        end;

  if Abs( a - (3 * Pi / 2) ) < 1e-4
   then begin

         cDX := 0;
         cDY := -1e4;

         Exit;

        end;

  cDY := Sin( a ) / Cos( a );
  cDX := 1.0      / cDY;

 end;

 function OnInt( a, b : Extended ) : Extended;

  function Between( r : Extended ): boolean;
  begin

   Between := ((r >= a) and (r <= b)) or
              ((r >= b) and (r <= a)) ;

  end;

  var   k       : Extended;
        i       : ShortInt;        

 begin

  k := Trunc( a );

  for i := -3 to 3 do
   if Between( k + i )
    then begin

          OnInt := k + i;

          Exit;

         end;

  OnInt := k;

 end;

 procedure GetFirst;
 begin

  if (cXI > 0) and (cDX < 0)
   then cDX := -cDX;

  if (cYI > 0) and (CDY < 0)
   then cDY := -cDY;

  if (cXI < 0) and (cDX > 0)
   then cDX := -cDX;

  if (cYI < 0) and (cDY > 0)
   then cDY := -cDY;

  X1 := OnInt( cX, cX + cXI );
  Y1 := Abs( X1 - cX ) * cDY + cY;

  Y2 := OnInt( cY, cY + cYI );
  X2 := Abs( Y2 - cY ) * cDX + cX;

 end;

 procedure GetCurrent;
 begin

  pX := cX;
  pY := cY;

  if Abs( X1 - sX ) + Abs( Y1 - sY ) < 
     Abs( X2 - sX ) + Abs( Y2 - sY )
      then begin

            First := True;

            cX := X1;
            cY := Y1;

            X1 := X1 + cXI;
            Y1 := Y1 + cDY;

           end
      else begin

            First := False;

            cX := X2;
            cY := Y2;

            X2 := X2 + cDX;
            Y2 := Y2 + cYI;

           end;

 end;

 procedure DrawLine( Low, High : LongInt; Color : Byte );
 var ii, Up, k : LongInt;
 begin

  if Low < 0
   then Low := 0;

  if High < hX
   then Up := High
   else Up := hX-1;

  k := 320 * Low + i;

  for ii := Low to Up do
  begin

   Scr^[ k ] := Color;

   Inc( k, 320 );

  end;

  if Low < hX
   then hX := Low;  

 end;
             
 procedure DrawTexturedLine( Low, High : LongInt; LowF, HighF : Extended; Row, Id : LongInt );
 var ii, Up, k : LongInt;
      CurCoord : Extended;
         Delta : Extended;
     Clr, Base : LongInt;
 begin  

  if (Id < 0) or (Id > TEXCOUNT) or ( Abs( HighF - LowF ) < 1e-3 )
   then begin
   
         DrawLine( Low, High, 210 );

         Exit;

        end;

  CurCoord := 0;
  Delta    := TexSize[ Id ] / (HighF - LowF);

  if Low < 0
   then Low := 0;

  CurCoord := (Low - LowF) * Delta;

  if High < hX
   then Up := High
   else Up := hX-1;

  k := 320 * Low + i;

  for ii := Low to Up do
  begin

   Clr := Tex[ Id ]^[ Row, Trunc( Round( CurCoord ) ) and (TexSize[ Id ]-1) ];

   if Clr <> ALPHACOLOR
    then begin

          Base := Clr and $E0;

          if Base > 192
           then Base := 192;

          Clr  := Clr - Base;

          Clr  := Trunc( Round( Clr * kAlpha ) );
          if Clr < 0  then Clr := 0;

          if Base = 192
           then begin

                 if Clr > 63 then Clr := 63;

                end
           else begin

                 if Clr > 31 then Clr := 31;

                end;

          Scr^[ k ] := Clr + Base;

         end;

   Inc( k, 320 );

   CurCoord := CurCoord + Delta;

  end;

  if Low < hX
   then hX := Low;  

 end;

 procedure SortSprites;
 var i, j : LongInt;
        x : TSprite;
 begin

  for i := 2 to SprCount do
  begin

   x := Spr[ i ]; j := i;

   while (j > 1) and (Spr[ j-1 ].Dist < x.Dist)
    do begin

        Spr[ j ] := Spr[ j-1 ];

        Dec( j );

       end;

   Spr[ j ] := x;

  end;

 end;

 function GetAngle( dX, dY : Extended ) : Extended;
 var vAngle : Extended;
 begin

  if Abs( dX ) < 1e-4
   then begin

         if dY > 0
          then GetAngle :=      Pi / 2
          else GetAngle := 3 * (Pi / 2);

         Exit;

        end;

  if Abs( dY ) < 1e-4
   then begin

         if dX > 0
          then GetAngle := 0
          else GetAngle := Pi;

         Exit;

        end;   

  vAngle := ArcTan( dY / dX );

  if dX < 0
   then vAngle := vAngle + Pi;

  if vAngle < 0
   then vAngle := vAngle + Pi + Pi;

  GetAngle := vAngle;

 end;

 procedure PutSprite( Num : LongInt; XX, YY : Extended; Scale, Height : Extended );
 var  NewAngle : Extended;
     Low, High : Extended;
      LwI, HwI : LongInt;
        Center : Extended;
       Current : Extended;
          Size : Extended;
          Dist : Extended;
          Base : Extended;
            ii : LongInt;
    dX, dY, sP : Extended;
 begin

  dX := Cos( Angle );
  dY := Sin( Angle );
  sP := dX * (XX - X) + dY * (YY - Y);

  if sP < 1e-4
   then Exit;

  NewAngle := GetAngle( XX - X, YY - Y ) - Angle;

  while NewAngle < -Pi/2 do NewAngle := NewAngle + Pi;
  while NewAngle > +Pi/2 do NewAngle := NewAngle - Pi;

  if NewAngle < -Pi/2 + 0.01 then NewAngle := -Pi/2 + 0.01;
  if NewAngle >  Pi/2 - 0.01 then NewAngle :=  Pi/2 - 0.01;

  Center := 160.0 + 160.0 * Sin( NewAngle ) / Cos( NewAngle );

  if Abs( Center ) > 400
   then Exit; 

  Dist   := SqRt( Sqr( XX - X ) + Sqr( YY - Y ) ) / 0.9 * Cos( NewAngle );

  if Dist < 1e-4
   then Dist := 1e-4;

  Size   := Scale / (Dist + 0.2);

  Low    := Center - 0.5 * Size;
  High	 := Center + 0.5 * Size;

  if Abs( High - Low ) < 1e-3
   then Exit;

  LwI    := Trunc( Low    );
  HwI	 := Trunc( High+1 );

  if LwI < 0
   then LwI := 0;

  if HwI > 319
   then HwI := 319;

  for ii := LwI to HwI do
   if Dist < Depths[ ii ]
    then  begin

          i := ii;

          kAlpha := ( 1 / (Dist/1.5 + 0.4) );

          hX  := 200;
          hXf := 200.0;

          Base := 100.0 - Height / (Dist + 0.2);

          DrawTexturedLine(
                           Trunc( Base - Size*0.5 ),
                           Trunc( Base + Size*0.5 ),
                           Base - Size * 0.5,
                           Base + Size * 0.5,
                           Trunc( Round( TexSize[ Num ] * (ii - Low) / (High - Low) ) ) and (TexSize[ Num ] - 1),
                           Num
                         );

         end;

 end;

 procedure DrawLineLow( Low, High : Extended );
 var ii, k, LowI, HighI : LongInt;
                  Alpha : Extended;
                TempClr : LongInt;
                 c1, c2 : Boolean;
 begin

  LowI  := Trunc( Low-1  );
  HighI := Trunc( High+2 );

  if LowI < 0
   then LowI := 0;

  if HighI > 200
   then HighI := 200;

  k := 320 * LowI + i;

  for ii := LowI to HighI do
  begin

   if (Low < ii) and (ii < High-1)
    then Scr^[ k ] := 192
    else begin

          if (ii+1 < Low) or (ii > High)
           then Continue;
                           
          c1 := (ii < Low)  and (Low < ii+1);
          c2 := (ii < High) and (High < ii+1);

          if c1 and c2
           then Alpha := 1.0 - Abs( High - Low );

          if c1 and not c2
           then Alpha := Frac( Low );

          if not c1 and c2
           then Alpha := 1.0 - Frac( High );

          if not c1 and not c2
           then Alpha := 1.0;

          TempClr := Trunc( Round( ((Scr^[ k ] - 192) * Alpha) + 192 ) );

          if TempClr < 192
           then TempClr := 192;

          if TempClr > 254
           then TempClr := 254;

          Scr^[ k ] := Byte( TempClr );

         end;
         

   Inc( k, 320 );

  end;

  hXf := Low;

 end;

begin

 for i := 0 to 319 do
 begin

  AngleDelta := ArcTan( (i / 160.0) + (-1.0) );

  a := Angle + AngleDelta;

  while a < 0
   do a := a + Pi + Pi;

  while a > Pi + Pi
   do a := a - Pi - Pi;

  cX := X * 2.0;
  cY := Y * 2.0;

  sX := cX;
  sY := cY;

  ComputeDeltas;
  GetFirst;

  hX  := 200;
  hXf := 200.0;

  kAlpha2 := Abs( Sin( a ) ) * 0.8 + 0.2;
  kAlpha1 := Abs( Cos( a ) ) * 0.8 + 0.2;  

  for j := 1 to STEPS do
  begin

   GetCurrent;

   MX := Trunc( 0.5 * cX + 0.5 * pX );
   MY := Trunc( 0.5 * cY + 0.5 * pY );

   TX := MX and 1;
   TY := MY and 1;

   MX := (MX shr 1) and 63;
   MY := (MY shr 1) and 63;

   if Map^[ MX, MY ] <> 0
    then begin

          Depths[ i ] := Cos( AngleDelta ) * SqRt( Sqr( pX - sX ) + Sqr( pY - sY ) )/1.8;

          if Depths[ i ] < 1e-4
           then Depths[ i ] := 1e-4;

          cDist := 100.0 / ( Depths[ i ] + 0.2 );          

          ttX := pX / 2.0;
          ttY := pY / 2.0;

          if Abs( ttX - Round( ttX ) ) < Abs( ttY - Round( ttY ) )
           then begin

                 if ffY 
                  then ttZ := Frac( ttY )
                  else ttZ := 1.0 - Frac( ttY );

                 kAlpha := kAlpha1;

                end
           else begin
           
                 if ffX
                  then ttZ := Frac( ttX )
                  else ttZ := 1.0 - Frac( ttX );

                 kAlpha := kAlpha2;

                end;

          kAlpha := kAlpha * ( 1 / (Depths[ i ]/1.5 + 0.4) );

          tXs := Map^[ MX, MY ];

          DrawTexturedLine(
                            Trunc( 100.0 - cDist ),
                            Trunc( 100.0 + cDist ),
                            100.0 - cDist,
                            100.0 + cDist,
                            Trunc( Round( ttZ * TexSize[ tXs ] ) ) and (TexSize[ tXs ]-1),
                            tXs                                                           
                          );

          Break; 

         end
    else begin

          Depths[ i ] := Cos( AngleDelta ) * SqRt( Sqr( cX - sX ) + Sqr( cY - sY ) )/1.8;

          if Depths[ i ] < 1e-4
           then Depths[ i ] := 1e-4;

          cDist := 100.0 / ( Depths[ i ] + 0.2 );          

          if (TX and 1) = (TY and 1)
           then DrawLineLow( 100.0 + cDist, hXf )
           else hXf := 100.0 + cDist;                

         end;
  
  end;

 end;

 { Render sprites }

 SortSprites; 

 for tXs := 1 to SprCount do
  PutSprite(

            Spr[ tXs ].Id,
            Spr[ tXs ].XX,
            Spr[ tXs ].YY,
            Spr[ tXs ].Scale,
            Spr[ tXs ].Diff

           );        

end;

procedure MakeSprite( Num : LongInt; XX, YY, Scale, Diff :  Extended );
begin

 Inc( SprCount );

 Spr[ SprCount ].Id	:= Num;
 Spr[ SprCount ].XX	:= XX;
 Spr[ SprCount ].YY	:= YY;
 Spr[ SprCount ].Scale  := Scale;
 Spr[ SprCount ].Diff	:= Diff;

 Spr[ SprCount ].Dist  := Sqr( X - XX ) + Sqr( Y - YY );

end;

procedure SpriteWorks;
var i, j : LongInt;
begin

 SprCount := 0;

 { Link to making sprites }

 for i := 1 to MONSTER_COUNT do
  with Monsters[ i ] do
   begin

    if Health <= 0
     then Continue;

    if Id = 1
     then j := 12
     else j := 14;

    if Moves > 0
     then j := 17;

    MakeSprite( j, XX, YY, 96, -30 );

   end;

 for i := 1 to ITEM_COUNT do
  with Items[ i ] do
   begin

    if IsMedikit = 0
     then MakeSprite( 10, XX, YY, 48, -50 );

    if IsMedikit = 1
     then MakeSprite( 11, XX, YY, 48, -50 );


   end;

 for i := 1 to BOTTLE_COUNT do
  with Bottles[ i ] do
   if Exist
    then MakeSprite( 16, XX, YY, 48, -50 );

 for i := 1 to MAX_FIRE do
  with Fires[ i ] do
   if Active
    then MakeSprite( 13, XX, YY, 48, -30 );

end;

function Collision( XX, YY : Extended ) : Boolean;
var MX, MY : LongInt;
    LB, RB, BB, TB : Boolean;
begin

 MX := Trunc( XX ) and 63;
 MY := Trunc( YY ) and 63;

 if Map^[ MX, MY ] <> 0
  then begin

        Collision := True;

        Exit;

       end;

 LB := (MX >  0) and (Map^[ MX-1, MY ] <> 0);
 RB := (MX < 63) and (Map^[ MX+1, MY ] <> 0);
 TB := (MY >  0) and (Map^[ MX, MY-1 ] <> 0);
 BB := (MY < 63) and (Map^[ MX, MY+1 ] <> 0);

 Collision := False;

 if LB and ( Frac( XX ) < PROXIMITY )
  then Collision := True;

 if RB and ( Frac( XX ) > 1.0 - PROXIMITY )
  then Collision := True;

 if TB and ( Frac( YY ) < PROXIMITY )
  then Collision := True;

 if BB and ( Frac( YY ) > 1.0 - PROXIMITY )
  then Collision := True;

end;

var	MovesLeft			: LongInt;
	AngleDiff			: Extended;

procedure CastFireball;
var ii : LongInt;
     f : Boolean;
begin

 if Timer - 35 < LastFire
  then Exit;

 if GameEnded
  then Exit;

 f := False;

 for ii := 1 to MAX_FIRE do
  if not Fires[ ii ].Active 
   then begin

         f := True;

         Break;

        end;

 if not f 
  then Exit;

 if FireballsLeft <= 0
  then Exit;

 LastFire := Timer;

 Dec( FireballsLeft );

 with Fires[ ii ] do
 begin

  Active := True;

  XX     := X;
  YY     := Y;

  dX     := Cos( Angle ) * FIRE_SPEED;
  dY     := Sin( Angle ) * FIRE_SPEED;

 end;

end;

function Escaped : Boolean;
var Ch       : Char;
    ssX, ssY : Extended;
    f1, f2   : Boolean;
         mbs : Word;
label OutCast;
begin

 MousePressed( mbs );

 if mbs = 1
  then begin AngleDiff :=   0.0 ; MovesLeft := MOVECOUNT; end;

 if mbs = 2
  then begin AngleDiff :=    Pi ; MovesLeft := MOVECOUNT; end;

 if mbs = 3
  then CastFireball;

 if KeyPressed then
 begin

  Ch := ReadKey;

  if Ch = #27
   then begin

         Escaped := True;

         Exit;

        end;

  case UpCase( Ch ) of

   'W' : begin AngleDiff :=   0.0 ; MovesLeft := MOVECOUNT; end;
   'S' : begin AngleDiff :=    Pi ; MovesLeft := MOVECOUNT; end;
   'D' : begin AngleDiff := +Pi/2 ; MovesLeft := MOVECOUNT; end;
   'A' : begin AngleDiff := -Pi/2 ; MovesLeft := MOVECOUNT; end;
   #32 : CastFireball;
   #9  : MapMode := not MapMode;

  end;

 end;

 if MovesLeft > 0 then
 begin

   ssX := X;
   ssY := Y;

   X   := ssX + SPEED * Cos( Angle + AngleDiff );
   Y   := ssY + SPEED * Sin( Angle + AngleDiff );

   Dec( MovesLeft );

   Escaped := False;

   f1 := Collision( X, Y );
   f2 := Collision( ssX, ssY );

   if not ( (f2 and f1) or not f1 )
    then begin

          if f1 and not f2
           then begin

                 if Abs(X - ssX) > Abs(Y - ssY)
                  then begin

                        if not Collision( X, ssY )
                         then begin

                               Y := ssY;

                               goto OutCast;

                              end;

                       end
                  else begin

                        if not Collision( ssX, Y )
                         then begin

                               X := ssX;

                               goto OutCast;

                              end;

                       end;

                 if Abs(X - ssX) < Abs(Y - ssY)
                  then begin

                        if not Collision( X, ssY )
                         then begin

                               Y := ssY;

                               goto OutCast;

                              end;

                       end
                  else begin

                        if not Collision( ssX, Y )
                         then begin

                               X := ssX;

                               goto OutCast;

                              end;

                       end;

                 X := ssX;
                 Y := ssY;

                 OutCast:;

                end
           else begin

                 X := ssX;
                 Y := ssY;

                end;

         end;

 end;

 Escaped := False;

end;

procedure PutPix( X, Y : LongInt; Color : Byte );
begin

 Scr^[ Y * 320 + X ] := Color;

end;

procedure DrawMap;
var dx1, dy1, dx2, dy2 : Extended;
    xxxx, yyyy	       : Extended;
    i, j, k	       : LongInt;
    mxx, myy	       : LongInt;
begin

 dx1 := Cos( Angle ) * (-MAP_SCALE);
 dy1 := Sin( Angle ) * (-MAP_SCALE);
 dx2 := Cos( Angle - (Pi/2) ) * (-MAP_SCALE);
 dy2 := Sin( Angle - (Pi/2) ) * (-MAP_SCALE);

 k := 0;

 for i := 0 to 199 do
  for j := 0 to 319 do
   begin

    xxxx := dx1 * (i - 100) + dy1 * (j-160);
    yyyy := dx2 * (i - 100) + dy2 * (j-160);

    xxxx := xxxx + X;
    yyyy := yyyy + Y;

    if (xxxx > -1) and (xxxx < 65) and (yyyy > -1) and (yyyy < 65)
     then if Collision( xxxx, yyyy )
           then begin

                 mxx := Trunc( xxxx );
                 myy := Trunc( yyyy );

                 if (mxx >= 0) and (mxx <= 63) and (myy >= 0) and (myy <= 63)
                  then if Map^[ mxx, myy ] <> 0
                           then Scr^[ k ] := 32 + 22;

                end;

    Inc( k );

   end;

 PutPix( 159,  99, 254 );
 PutPix( 161,  99, 254 );
 PutPix( 158, 100, 254 );
 PutPix( 162, 100, 254 );

 PutPix( 160,  98, 254 );
 PutPix( 160,  99, 254 );
 PutPix( 160, 100, 254 );
 PutPix( 160, 101, 254 );
 PutPix( 160, 102, 254 );

end;

procedure SetupMouse;
begin

 asm

  mov	ax, 7
  mov	cx, 0
  mov	dx, 1000
  int	33h

  mov	ax, 8
  mov	cx, 0
  mov	dx, 0
  int	33h

 end;

end;

procedure LoadTex( Num : LongInt; FileName : String );
var i, j : LongInt;
     inF : Text;
      cc : Char;
begin

 if Tex[ Num ] <> nil
  then Dispose( Tex[ Num ] );

 New( Tex[ Num ] );

 Assign( inF, FileName ); ReSet( inF );

 ReadLn( inF, TexSize[ Num ] );

 for j := 0 to TexSize[ Num ]-1 do
 begin

  for i := 0 to TexSize[ Num ]-1 do
  begin

   Read( inF, cc );

   case cc of

    'R' : Tex[ Num ]^[ i, j ] := 31;
    'r' : Tex[ Num ]^[ i, j ] := 15;

    'G' : Tex[ Num ]^[ i, j ] := 31 + 32;
    'g' : Tex[ Num ]^[ i, j ] := 15 + 32;

    'B' : Tex[ Num ]^[ i, j ] := 31 + 64;
    'b' : Tex[ Num ]^[ i, j ] := 15 + 64;

    'Y' : Tex[ Num ]^[ i, j ] := 31 + 96;
    'y' : Tex[ Num ]^[ i, j ] := 15 + 96;

    'O' : Tex[ Num ]^[ i, j ] := 31 + 128;
    'o' : Tex[ Num ]^[ i, j ] := 18 + 128;

    'C' : Tex[ Num ]^[ i, j ] := 14 + 128;
    'c' : Tex[ Num ]^[ i, j ] :=  8 + 128;

    'N' : Tex[ Num ]^[ i, j ] := 31 + 128 + 32;
    'n' : Tex[ Num ]^[ i, j ] := 15 + 128 + 32;

    'w' : Tex[ Num ]^[ i, j ] := 192;
    'k' : Tex[ Num ]^[ i, j ] := 224;
    'K' : Tex[ Num ]^[ i, j ] := 235;
    'W' : Tex[ Num ]^[ i, j ] := 254;

    else Tex[ Num ]^[ i, j ]  := ALPHACOLOR;

   end;

  end; 

  ReadLn( inF );

 end;

 Close( inF );
 
end;

procedure LoadTextures;
var i : LongInt;
begin

 for i := 0 to 9
  do Tex[ i ] := nil;

 LoadTex(  1, 'Textures\tex1.dat' ); 
 LoadTex(  2, 'Textures\tex2.dat' );
 LoadTex(  3, 'Textures\tex3.dat' );
 LoadTex(  4, 'Textures\tex4.dat' );
 LoadTex(  5, 'Textures\tex5.dat' );
 LoadTex(  6, 'Textures\tex6.dat' );
 LoadTex(  7, 'Textures\tex7.dat' );
 LoadTex(  8, 'Textures\tex8.dat' );
 LoadTex(  9, 'Textures\tex9.dat' );         
 LoadTex( 10, 'Textures\spAid.dat' );         
 LoadTex( 11, 'Textures\torch.dat' );
 LoadTex( 12, 'Textures\fire.dat' );
 LoadTex( 13, 'Textures\fireball.dat' );
 LoadTex( 14, 'Textures\vital.dat' );
 LoadTex( 15, 'Textures\spFreeze.dat' );
 LoadTex( 16, 'Textures\bottle.dat' );
 LoadTex( 17, 'Textures\flame.dat' );

end;

procedure DestroyTextures;
var i : LongInt;
begin

 for i := 0 to 9 do
  if Tex[ i ] <> nil
   then Dispose( Tex[ i ] );

end;

{ --- AI and game logic code --- }


procedure PutPixText( X, Y : LongInt; Color : Byte );
begin

 if (X >= 0) and (X <= 319) and
    (Y >= 0) and (Y <= 199)
     then Scr^[ 320 * Y + X ] := Color;

end;

procedure DrawChar( X, Y : LongInt; cc : Char; Color : Byte );
var xx, yy, ii : LongInt;
begin

 for ii := 1 to SimCount do
  if cc = Sims[ ii ]
   then begin

         for xx := 1 to 5 do
          for yy := 1 to 5 do
           if Faces[ ii, yy, xx ] = 1
            then PutPixText( X-1+xx, Y-1+yy, Color );

         Break;

        end;

end;

procedure DrawText( X, Y : LongInt; Textual : String; Color : Byte );
var i : LongInt;
begin

 for i := 1 to Length( Textual ) do
  DrawChar( X + (i-1) * 6, Y, Textual[ i ], Color );

end;

procedure Respawn( Node : LongInt );
begin

 with Monsters[ Node ] do
  repeat

   XX := Random * 64;
   YY := Random * 64;

   dX := XX;
   dY := YY;

   Moves := 0;

   if Random > 0.8
    then begin

          Id := 2;

          Health := 160;

         end
    else begin

          Id := 1;

          Health := 80;

         end;

  until not Collision( XX, YY ) and ( SqRt( Sqr( X - XX ) + Sqr( Y - YY ) ) > RESPAWN_DISTANCE );

end;

procedure RespawnInitialMonsters;
var i : LongInt;
begin

 for i := 1 to MONSTER_COUNT do
  Monsters[ i ].Health := 0;

 for i := 1 to MONSTER_COUNT do
  Respawn( i );

end;

procedure RespawnMonsters;
var i : LongInt;
begin

 for i := 1 to MONSTER_COUNT do
  with Monsters[ i ] do
   begin

    if Health > 0
     then begin

           if Moves > 0
            then begin

                  Dec( Health, 4 );

                  if Health < 0
                   then Health := 0;

                  Dec( Moves );

                 end;

          end
     else begin

           Respawn( i );

          end;

   end;

end;

procedure RespawnItem( Num : LongInt );
begin

 with Items[ Num ] do
 begin

  if Random > 0.85
   then IsMedikit := 1
   else IsMedikit := 0;

  repeat

   XX := 64.0 * Random;
   YY := 64.0 * Random;

  until not Collision( XX, YY );

 end;

end;

procedure RespawnBottles;
var ii : LongInt;
begin

 BottlesLeft := BOTTLE_COUNT - 10;

 for ii := 1 to BOTTLE_COUNT do
  with Bottles[ ii ] do
   begin

    Exist := True;

    repeat

     XX := 64 * Random;
     YY := 64 * Random;

    until not Collision( XX, YY ) and ( SqRt( Sqr( XX - X ) + Sqr( YY - Y ) ) > RESPAWN_DISTANCE );

   end; 

end;

procedure RecheckBottles;
var ii : LongInt;
    dL : Extended;
begin

 for ii := 1 to BOTTLE_COUNT do
  with Bottles[ ii ] do
   begin

    if Exist
     then begin

           dL := SqRt( Sqr( XX - X ) + Sqr( YY - Y ) );

           if dL < ATTACK_PROXIMITY
            then begin

                  if BottlesLeft > 0
                   then Dec( BottlesLeft );

                  Exist := False;

                 end;

          end;

   end;

end;

procedure RespawnItems;
var i  : LongInt;
    dL : Extended;
begin

 for i := 1 to ITEM_COUNT do
  with Items[ i ] do
   begin

    dL := SqRt( Sqr( XX - X ) + Sqr( YY - Y ) );

    if dL < ATTACK_PROXIMITY
     then begin

           if IsMedikit = 0
            then begin

                  if PlayerHealth < 100
                   then begin

                         Inc( PlayerHealth, 10 );
                         
                         if PlayerHealth > 100
                          then PlayerHealth := 100;

                         RespawnItem( i );

                         Continue;

                        end;

                 end;

           if IsMedikit = 1
            then begin

                  if FireballsLeft < 15
                   then begin

                         Inc( FireballsLeft, 3 );
                                             
                         if FireballsLeft > 15
                          then FireballsLeft := 15;

                         RespawnItem( i );

                         Continue;

                        end;

                 end;


          end;

   end;

end;

procedure RespawnInitialItems;
var i : LongInt;
begin

 for i := 1 to ITEM_COUNT do
  Items[ i ].IsMedikit := 2;

 for i := 1 to ITEM_COUNT do
  RespawnItem( i );

end;

type	TCoord				= record

					   X, Y : ShortInt;

					  end;
					  
	PQueue				= ^TQueue;
	TQueue				= record

					   Cnt  : LongInt;
					   Vals : array [0..2000] of TCoord;

					  end;		

var	Prev				: array [0..63, 0..63] of TCoord;
	Vis				: array [0..63, 0..63] of Boolean;
	Path				: array [0..63, 0..63] of Word;

	Queue				: array [0..3] of PQueue;

	lPx, lPy			: LongInt;
	ChangedBfs			: Boolean;

procedure AllocQueues;
begin

 New( Queue[ 0 ] );
 New( Queue[ 1 ] );
 New( Queue[ 2 ] );
 New( Queue[ 3 ] );

end;

procedure DestroyQueues;
begin

 Dispose( Queue[ 0 ] );
 Dispose( Queue[ 1 ] );
 Dispose( Queue[ 2 ] );
 Dispose( Queue[ 3 ] );

end;

procedure MoveMonsters;

 var i            : LongInt;
     ddX, ddY, dL : Extended;
     j		  : LongInt;

     cSpeed	  : Extended;

 const dXX : array [0..7] of Extended = ( -1.0,  0.0, +1.0, +1.0, +1.0,  0.0, -1.0, -1.0 );
       dYY : array [0..7] of Extended = ( +1.0, +1.0, +1.0,  0.0, -1.0, -1.0, -1.0,  0.0 );

 function EdgeWorks( X1, Y1, X2, Y2 : Extended ) : Boolean;
 begin

  EdgeWorks := not (

   Collision( X1 * 0.25 + X2 * 0.75, Y1 * 0.25 + Y2 * 0.75 ) or
   Collision( X1 * 0.50 + X2 * 0.50, Y1 * 0.50 + Y2 * 0.50 ) or
   Collision( X1 * 0.75 + X2 * 0.25, Y1 * 0.75 + Y2 * 0.25 ) or
   Collision( X1 * 0.00 + X2 * 1.00, Y1 * 0.00 + Y2 * 1.00 )

  );

 end;

 procedure Bfs;

  var i, j, ni, nj : LongInt;
             k, cc : LongInt;
              CurQ : LongInt;
            pDelta : LongInt;

  function FreeCellsExist : Boolean;
  begin

   FreeCellsExist := not (
                           (Queue[ 0 ]^.Cnt = 0) and
     		           (Queue[ 1 ]^.Cnt = 0) and
     		           (Queue[ 2 ]^.Cnt = 0) and
     		           (Queue[ 3 ]^.Cnt = 0) 
     		         );

  end;

  procedure PutQueue( Num, X_, Y_ : ShortInt );
  begin

   with Queue[ (CurQ + Num) and 3 ]^ do
   begin

    Vals[ Cnt ].X := X_;
    Vals[ Cnt ].Y := Y_;

    Inc( Cnt );

   end;

  end;

 begin

  CurQ := 0;

  for i := 0 to 3 do
   Queue[ i ]^.Cnt := 0;

  ni := Trunc( X );
  nj := Trunc( Y );

  if (ni = lPX) and (nj = lPy)
   then Exit;

  PutQueue( 0, ni, nj );

  lPx := ni;
  lPy := nj;

  ChangedBfs := True;

  for i := 0 to 63 do
   for j := 0 to 63 do
    begin

     Vis  [ i, j ] := False;
     Path [ i, j ] := 0;

    end;

  Vis[ ni, nj ] := True;

  Prev[ ni, nj ].X := ni;
  Prev[ ni, nj ].Y := nj;

  while FreeCellsExist do
  begin

   for cc := 0 to Queue[ CurQ ]^.Cnt-1 do
   begin

    i := Queue[ CurQ ]^.Vals[ cc ].X;
    j := Queue[ CurQ ]^.Vals[ cc ].Y;

    for k := 0 to 7 do
    begin

     ni := i + Trunc( dXX[ k ] );
     nj := j + Trunc( dYY[ k ] );

     if EdgeWorks( i + 0.5, j + 0.5, ni + 0.5, nj + 0.5 )
      then if not Vis[ ni, nj ]
       then begin

             if Abs( ni - i ) + Abs( nj - j ) = 2
              then pDelta := 3
              else pDelta := 2;

             Vis[ ni, nj ] := True;

             Prev[ ni, nj ].X := i;
             Prev[ ni, nj ].Y := j;

             PutQueue( pDelta, ni, nj );

             Path[ ni, nj ] := Path[ i, j ] + pDelta;

            end;

    end;

   end;

   Queue[ CurQ ]^.Cnt := 0;
   CurQ := (CurQ + 1) and $03;

  end;

 end;

 function CheckMovement( XXX, YYY : Extended; var dX, dY : Extended ) : Boolean;
 var k      : LongInt;
     eX, eY : Extended;
 begin

  k := Random( 8 );

  eX := XXX + dXX[ k ] + (Random - 0.5) * 0.22;
  eY := YYY + dYY[ k ] + (Random - 0.5) * 0.22;

  if EdgeWorks( XXX, YYY, eX, eY )
           then begin

                 CheckMovement := True;

                 dX            := eX;
                 dY	       := eY;

                end
           else CheckMovement := False;

 end;

 label	OutCast;

 var	fDist			: Boolean;

begin

 Bfs;

 for i := 1 to MONSTER_COUNT do
  with Monsters[ i ] do
   if Health > 0
    then begin

          fDist := Path[ Trunc( XX ) and 63, Trunc( YY ) and 63 ] < DISTANCE;

          if (( Abs( XX - dX ) > 0.3e-1 ) or ( Abs( YY - dY ) > 0.3e-1 )) and
             ((not ChangedBfs) or (not fDist))
           then begin

                 ddX := dX - XX;
                 ddY := dY - YY;

                 dL  := SqRt( Sqr( ddX ) + Sqr( ddY ) );

                 if Abs( dL ) < 1e-3
                  then dL := 1.0;

                 ddX := ddX / dL;
                 ddY := ddY / dL;

                 if Id = 1
                  then cSpeed := 0.04
                  else cSpeed := 0.025;

                 if  dL > cSpeed
                  then begin

                        XX := XX + ddX * cSpeed ;
                        YY := YY + ddY * cSpeed ;

                       end
                  else begin

                        XX := XX + ddX * dL ;
                        YY := YY + ddY * dL ;

                       end;

                end
           else begin

                 if fDist
                  then begin

                        if (Trunc( XX ) and 63 = Trunc( X ) and 63) and
                           (Trunc( YY ) and 63 = Trunc( Y ) and 63)
                            then begin

                                  dX := X;
                                  dY := Y;

                                 end
                            else begin

                                  dX := Prev[ Trunc( XX ) and 63, Trunc( YY ) and 63 ].X + 0.5 + (Random - 0.5) * 0.22;
                                  dY := Prev[ Trunc( XX ) and 63, Trunc( YY ) and 63 ].Y + 0.5 + (Random - 0.5) * 0.22;

                                 end;                       

                       end
                  else begin

                        for j := 1 to 8 do
                         if CheckMovement( XX, YY, dX, dY )
                          then goto OutCast;

                        dX := XX;
                        dY := YY;

                        OutCast:;

                       end;

                end;

         end;

 ChangedBfs := False;

end;

var	GoodFrame				: LongInt;

function Damaged : Boolean;
var i            : LongInt;
    ddX, ddY, dL : Extended;
             dmg : Boolean;
begin

 dmg := False;

 Inc( GoodFrame ); if GoodFrame = 2 then GoodFrame := 0;

 for i := 1 to MONSTER_COUNT do
  with Monsters[ i ] do
   if (Health > 0) and (Moves = 0)
    then begin

          ddX := XX - X;
          ddY := YY - Y;

          dL := SqRt( Sqr( ddX ) + Sqr( ddY ) );

          if dL < ATTACK_PROXIMITY
           then begin

                 if Id = 1
                  then if (i mod 3) = (Timer mod 3)
                        then begin

                              dmg := True;

                              PlayerHealth := PlayerHealth - 2;
                              if PlayerHealth < 0
                               then PlayerHealth := 0;

                             end;

                 if Id = 2
                  then if (i mod 4) = (Timer mod 4)
                        then begin

                              dmg := True;

                              PlayerHealth := PlayerHealth - 10;
                              if PlayerHealth < 0
                               then PlayerHealth := 0;

                             end;

                end;

         end;

 if dmg and (GoodFrame = 0)
  then begin
        
        Damaged := True;

        for i := 0 to 320*200-1 do
         Scr^[ i ] := 25;

        Exit;

       end;

 Damaged := False;

end;

{ --- FPS counter            --- }

var	LastTimer			: LongInt;
	Count				: LongInt;

	LastFPS				: LongInt;

procedure InitFPS;
var ii : LongInt;
begin

 LastTimer := Timer;
 Count	   := 0;

end;

procedure ShowFPS;
var CurTime : LongInt;
begin

 Inc( Count );
 CurTime := Timer;

 if CurTime - LastTimer >= 18
  then begin

        LastFPS := Trunc( Round( Count * 18.2 * 3 / (CurTime - LastTimer) ) );

        LastTimer := CurTime;
        Count	  := 0;

       end; 

 DrawText( 5, 5, 'FPS:', 230 );

 if LastFPS >= 1000
  then DrawChar( 30, 5, Chr((LastFPS div 1000) + Ord('0')), 255 );

 if LastFPS >= 100
  then DrawChar( 36, 5, Chr((LastFPS div 100) mod 10 + Ord('0')), 255 );

 if LastFPS >= 10
  then DrawChar( 42, 5, Chr((LastFPS div 10) mod 10 + Ord('0')), 255 );

 if LastFPS >= 0
  then DrawChar( 48, 5, Chr((LastFPS div 1) mod 10 + Ord('0')), 255 );

end;	

{ --- main game logic        --- }

procedure SetupGame;
begin

 PlayerHealth  := 100;
 FireballsLeft :=   5;

end;

procedure HudDraw;
var aNum : String;
    Color: LongInt;
begin
           
 DrawText(  250-00, 5, 'HEALTH:', 230 );
 DrawText(  250-18, 11, 'FIREBALLS:', 230 );
 DrawText(  250-06, 17, 'BOTTLES:', 230 );


 Str( PlayerHealth, aNum );
 
 case PlayerHealth of
  66..100: Color := 31 + 32;
  33..65 : Color := 31 + 96;
  else Color := 31;

 end;

 DrawText(  250+45,  5, aNum, Color );

 Str( FireballsLeft, aNum );
 DrawText(  250+45, 11, aNum, 255 );

 Str( BottlesLeft, aNum );
 DrawText(  250+45, 17, aNum, 255 );


end;

{ --- main operational body  --- }

procedure SplashScreen;
var k : LongInt;
begin

 for k := 0 to 320*200-1 do
  Scr^[ k ] := 192;

 DrawText( 20, 20, 'FEARFUL DUNGEONS OF MOIPK I PRR I SO', 31 );

 DrawText( 20, 32+00, 'ONCE UPON A TIME A LONELY STUDENT NAMED DIMKA', 255 );
 DrawText( 20, 32+06, 'TRAPPED INTO MYSTERIOUS AND FEARFUL DUNGEOUNS', 255 );
 DrawText( 20, 32+12, 'OF MOIPK. HE WAS ALREADY  SUFFERING FROM  HIS', 255 );
 DrawText( 20, 32+18, 'LAST HOLIDAY AT THAT MOMENT.  WITH TERRIBLE  ', 255 );
 DrawText( 20, 32+24, 'HEADACHE PLAGUING HIM HE HAD ONLY ONE CHOICE:', 255 );
 DrawText( 20, 32+30, 'TO COLLECT  30 BOTTLES OF SAM AND DRINK THEM.', 255 );
 DrawText( 20, 32+36, 'BUT HIS TASK IS NOT SO EASY. THERE ARE QUITE ', 255 );
 DrawText( 20, 32+42, 'A FEW MONTERS THERE...                       ', 255 );

 DrawText( 20, 92+00, 'BUT HIS STATE IS NOT SO HOPELESS. DUNGEONS OF', 255 );
 DrawText( 20, 92+06, 'MOIPK ARE FULL OF ANCIENT MAGIC, SO EVEN DIMKA', 255 );
 DrawText( 20, 92+12, 'DISCOVERED SOME MAGICAL ABILITIES WITHIN HIS', 255 );
 DrawText( 20, 92+18, 'BODY. THIS SIMPLIFIES HIS TASK A LOT... MAYBE', 255 );

 DrawText( 20, 162+24, 'PRESS ANY KEY TO CONTINUE...', 31 );


 Flip;

 while not KeyPressed do ;

 ReadKey;

end;

procedure FinalCountdown;
begin

 while ( (PlayerHealth = 0) or (BottlesLeft = 0) ) and not Escaped
  do begin

      MousedAngle;

      SpriteWorks;
      Backbuf;
      Render;

      if BottlesLeft = 0
       then DrawText( 151, 95, 'YOU WIN...', 255 ) else
      if PlayerHealth = 0
       then DrawText( 145, 95, 'YOU LOSE...', 255 );


      Flip;

      Delay( 5 );
      

     end;

end;

procedure Epilogue;
var k : LongInt;
begin

 for k := 0 to 320*200-1 do
  Scr^[ k ] := 192;

 DrawText( 20, 20, 'RESPONSIBLE FOR ALL THIS STUFF ARE :', 31 );

 DrawText( 20, 32+00, ' ONE     :: 2.5D ENGINE, GENERIC PROGRAMMING', 255 );
 DrawText( 20, 32+06, ' S1      :: TEXTURES AND GENERIC ARTWORK', 255 );
 DrawText( 20, 32+12, ' VITAL   :: MAP GENERATOR', 255 );
 DrawText( 20, 32+18, ' ROMKA   :: MORAL, FOOD AND WORKPLACE SUPPORT  ', 255 );
 DrawText( 20, 32+30, ' SMIT    :: WYSIWYG TEXTURE EDITOR', 255 );
 DrawText( 20, 32+36, ' MIX     :: BETA TESTING ', 255 );
 DrawText( 20, 32+42, ' ILYA    :: SUPERVISING                       ', 255 );
 DrawText( 20, 32+53, ' SHADOW  :: DEVELOPMENT MACHINES', 255 );
 DrawText( 20, 92+06, 'SPECIAL THANKS GOES TO DMITRY NIKITIN FOR BEING', 191 );
 DrawText( 20, 92+12, 'THE PROTOTYPE OF THE MAIN HERO', 191 );

 DrawText( 20, 107+12, 'COPYRIGHT 17.03.2006 05:33:47 SBORYSOFT', 63 );

 Flip;

 k := Timer;

 while (Timer - k < 150) and not KeyPressed do Delay( 1 );

end;


{ --- splash screen          --- }

procedure InitFireball;
var ii : LongInt;
begin

 for ii := 1 to MAX_FIRE do
  with Fires[ ii ] do
   Active := False;

end;

procedure ProcessFireballs;
var ii, jj : LongInt;
         f : Boolean;
        dL : Extended;
begin

 for ii := 1 to MAX_FIRE do
  with Fires[ ii ] do
   begin

    if not Active 
     then Continue;

    f := Collision( XX, YY );

    { --- check for collision }

    for jj := 1 to MONSTER_COUNT do
     with Monsters[ jj ] do
      if Health > 0
       then begin
                      
             dL := SqRt( SqR( Fires[ ii ].XX - Monsters[ jj ].XX ) + SqR( Fires[ ii ].YY - Monsters[ jj ].YY ) );

             if dL < FIREBALL_PROXIMITY
              then begin

                    f := True;

                    Break;

                   end;

            end;

    if f
     then begin

           Active := False;

           for jj := 1 to MONSTER_COUNT do
            with Monsters[ jj ] do
             if Health > 0
              then begin

                    dL := SqRt( SqR( Fires[ ii ].XX - Monsters[ jj ].XX ) + SqR( Fires[ ii ].YY - Monsters[ jj ].YY ) );

                    if dL < 1.8
                     then Monsters[ jj ].Moves := 20;

                   end;

          end
     else begin

           XX := XX + dX;
           YY := YY + dY;

          end;

   end;

end;

procedure InitBfs;
begin

 lPx := MaxLongInt;
 lPy := MaxLongInt;

 ChangedBfs := False;

end;

{ ------------------------------ }

begin

 {$IFDEF LOGGING}
 Assign( ouf, 'debug.log' ); ReWrite( ouf );
 {$ENDIF}

{ RandSeed  := 7031; } Randomize;
 GoodFrame := 0;

 InitBfs;

 New( Scr );
 New( Map );

 AllocQueues;

 InitFPS;
 SetupGame;                                                             

 ReadMap;
 LoadTextures;

 BeginVideo;
 SetPalette;   

 SplashScreen;

 SetupGuy;
 RespawnInitialMonsters;
 RespawnInitialItems;
 RespawnBottles;

 SetupMouse;

 InitFireball;

 GameEnded := False;

 LastFire  := -1;

 _('Before');

 repeat

  _('Fireballs');
  ProcessFireballs;

  _('Sprites');
  SpriteWorks;
  _('Backbuf');
  Backbuf;
  _('Rendering');
  Render;

  _('Damage dealing');
  Damaged; 

  _('Mapping');
  if MapMode
   then DrawMap;

  _('Hud & FPS');
  ShowFPS;
  HudDraw;

  _('Flipping');
  Flip;

  _('Monsterz');
  RespawnMonsters;
  MoveMonsters;

  Delay( 5 );

  _('Mouse works');
  MousedAngle;

  _('Item respawn');  
  RespawnItems;
  RecheckBottles;

  _('Escape');
  
 until Escaped or (PlayerHealth = 0) or (BottlesLeft = 0);

  _('End titles');

 GameEnded := True;

 FinalCountdown;

 Epilogue;

 EndVideo;

 DestroyTextures;
 DestroyQueues;
 Dispose( Scr );
 Dispose( Map );

 {$IFDEF LOGGING}
 Close( ouf );
 {$ENDIF}

end.